unit CateTerm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, Cate, StdCtrls;

type
	TCateMain = class(TForm)
    Memo1: TMemo;
    CateComm: TCate;
		procedure CateCommBreak(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommCts(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommCtss(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommDsr(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommErr(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommPErr(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommReceive(Sender: TObject; Count: Word);
		procedure CateCommRing(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommRingTE(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommRlsd(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommRlsds(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommRxChar(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommRxFlag(Sender: TObject; CommEvent: TCommEvents);
		procedure CateCommTransmit(Sender: TObject; Count: Word);
		procedure CateCommTxEmpty(Sender: TObject; CommEvent: TCommEvents);
		procedure Memo1KeyPress(Sender: TObject; var Key: Char);
		procedure Memo1Enter(Sender: TObject);
  private
		{ Private declarations }
    SendBuffer: array[0..255] of char;
  public
    { Public declarations }
  end;

var
	CateMain: TCateMain;

implementation

{$R *.DFM}

procedure TCateMain.CateCommBreak(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_BREAK event');
end;

procedure TCateMain.CateCommCts(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_CTS event');
end;

procedure TCateMain.CateCommCtss(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_CTSS event');
end;

procedure TCateMain.CateCommDsr(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_DSR event');
end;

procedure TCateMain.CateCommErr(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got an EV_ERR event');
end;

procedure TCateMain.CateCommPErr(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_PERR event');
end;

procedure TCateMain.CateCommReceive(Sender: TObject; Count: Word);
var
	ReceivedData: array[0..255] of char;
	Index: Integer;
begin
	for Index := 0 to 255 do				{Clear ReceiveData array prior to getting port data}
		ReceivedData[Index] := #0;
	CateComm.Read(@ReceivedData, 255);
	Memo1.Lines.Add(StrPas(ReceivedData));
end;

procedure TCateMain.CateCommRing(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_RING event');
end;

procedure TCateMain.CateCommRlsd(Sender: TObject; CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_RLSD event');
end;

procedure TCateMain.CateCommRlsds(Sender: TObject;  CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_RLSDS event');
end;

procedure TCateMain.CateCommRxChar(Sender: TObject;  CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_RXCHAR event');
end;

procedure TCateMain.CateCommRxFlag(Sender: TObject;	CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_RXFLAG event');
end;

procedure TCateMain.CateCommTransmit(Sender: TObject; Count: Word);
begin
	Memo1.Lines.Add ('Got a TRANSMIT event');
end;

procedure TCateMain.CateCommTxEmpty(Sender: TObject;	CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_TXEMPTY event');
end;

procedure TCateMain.CateCommRingTE(Sender: TObject;	CommEvent: TCommEvents);
begin
	Memo1.Lines.Add ('Got a EV_RINGTE event');
end;

procedure TCateMain.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
	if (Key = #10) or (Key = #13) then	{Send the string to port}
	begin
		StrCat(SendBuffer, @Key);					{Perhaps not necessary?}
		CateComm.Write(@SendBuffer, StrLen(SendBuffer));
		Memo1Enter(Self);									{Shortcut to clear SendBuffer}
	end else														{Store character in string}
	begin
		StrCat(SendBuffer, @Key);
	end;
end;

procedure TCateMain.Memo1Enter(Sender: TObject);
var
	Index: Integer;
begin
	for Index := 0 to 255 do
		SendBuffer[Index] := #0;
end;

initialization
end.
